<?php
 
 
 

namespace PhpWA\Protocol\Proto\BotQuotaMetadata;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class BotFeatureQuotaMetadata extends \Google\Protobuf\Internal\Message
{
    


    protected $featureType = null;
    


    protected $remainingQuota = null;
    


    protected $expirationTimestamp = null;

    










    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getFeatureType()
    {
        return isset($this->featureType) ? $this->featureType : 0;
    }

    public function hasFeatureType()
    {
        return isset($this->featureType);
    }

    public function clearFeatureType()
    {
        unset($this->featureType);
    }

    




    public function setFeatureType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\BotQuotaMetadata\BotFeatureQuotaMetadata\BotFeatureType::class);
        $this->featureType = $var;

        return $this;
    }

    



    public function getRemainingQuota()
    {
        return isset($this->remainingQuota) ? $this->remainingQuota : 0;
    }

    public function hasRemainingQuota()
    {
        return isset($this->remainingQuota);
    }

    public function clearRemainingQuota()
    {
        unset($this->remainingQuota);
    }

    




    public function setRemainingQuota($var)
    {
        GPBUtil::checkUint32($var);
        $this->remainingQuota = $var;

        return $this;
    }

    



    public function getExpirationTimestamp()
    {
        return isset($this->expirationTimestamp) ? $this->expirationTimestamp : 0;
    }

    public function hasExpirationTimestamp()
    {
        return isset($this->expirationTimestamp);
    }

    public function clearExpirationTimestamp()
    {
        unset($this->expirationTimestamp);
    }

    




    public function setExpirationTimestamp($var)
    {
        GPBUtil::checkUint64($var);
        $this->expirationTimestamp = $var;

        return $this;
    }

}

